QGIS Application - Bug report #16967

value relation widget with Allow multiple selection doesn't resolve the values anymore

2017-08-04 06:45 AM - Tudor Barascu

Status: Closed

Priority: High

Assignee: Alessandro Pasotti
Category: Edit widget

Affected QGIS version:master
Operating System: Debian Stretch
Pull Request or Patch supplied:
Crashes QGIS or corruptsdata:

Regression?: Yes
Easy fix?: No
Resolution:

Copied to github as #: 24866

Description

Steps to reproduce:

- Add a PostgreSQL layer with a integer[] column

- Add a Value relation layer and point it to the array column
- The values get saved in the DB when creating a feature

- The widget cannot present the values stored in the database when the feature form gets popped and the user can overwrite them

without knowing

I've also attached a GIF.

value_relation_bug.gif

Associated revisions

Revision 4f05ed1d - 2018-03-15 03:11 PM - Alessandro Pasotti

[bugfix] value relation widget with Allow multiple selection doesn't resolve

Now it will accept arrays as well as string representations of arrays

Added a test

Fixes #16967 value relation widget with Allow multiple selection doesn't resolve the values anymore

History

#1 - 2017-08-04 09:38 AM - Giovanni Manghi
- Priority changed from Normal to High

#2 - 2017-11-06 03:05 PM - Matthias Kuhn

Tudor, any chance you can provide a sample database and project?

#3 - 2017-11-07 07:55 AM - Tudor Barascu
- File bug.jpg added

Sure!
| think instead of a dump and a project it's easier to just create the tables:
CREATE TABLE test (id serial PRIMARY KEY, location integer[], geom geometry(Point, 4326));
CREATE TABLE location_type (id serial PRIMARY KEY, value text);

INSERT INTO location_type (value) VALUES ('sidewalk');
INSERT INTO location_type (value) VALUES (‘asphalt');

INSERT INTO location_type (value) VALUES ('sand’);
INSERT INTO location_type (value) VALUES ('soil');]]

add the layers in a project, and configure the location widget as a value relation like so:

Layer Properties - test | Fields x
Attribute editor layout | Autogenerate = Python Init function ;- v._
w Fields
B R |/ &)
Id ' Name Edit widget Alias Type Type name Length Precision C
123 0 id Text Edit | int int4 -1 0
| value Relation | QVariantList
Edit Widget Properties - location (test) x
Widget Type
Checkbox
Classification Select layer, kgy cplumn and value column
Color Layer :=| location_type -
Date/Time Y = L
Key column | 123id - |
Hidden Value column | abe value - |
List v| Allow NULL value
Relation Reference Order by value
| Text Edit ) )
Unique Values v | Allow multiple selections

Use completer

Value Mai
Value Relation Filter expression | £ |

| Editable w Constraints

Then, add a new point and select some of the locations.
They will get saved in the database.

However, opening the form on the same point shows an empty location part.

Thanks!

#4 - 2018-02-23 11:09 AM - Luigi Pirelli
- Assignee set to Luigi Pirelli
investigating

#5 - 2018-03-02 11:28 AM - Luigi Pirelli

seems the error is here:

https://github.com/qgis/QGIS/blob/master/src/core/fieldformatter/qgsvaluerelationfieldformatter.cpp#L57

misformatting the string list... the result resutn a empty list.
debugging the value is simply an Int array

find the way to correctly generate the keyList

#6 - 2018-03-15 03:15 PM - Alessandro Pasotti

- Assignee changed from Luigi Pirelli to Alessandro Pasotti

#7 - 2018-03-15 04:49 PM - Alessandro Pasotti

- Status changed from Open to In Progress

- Pull Request or Patch supplied changed from No to Yes

PR https://github.com/qgis/QGIS/pull/6615

#8 - 2018-03-15 05:09 PM - Anonymous
- % Done changed from 0 to 100
- Status changed from In Progress to Closed

Applied in changeset commit:qgis|4f05ed1dd7a9b3eb831efcccd5fe9ebe53chb37d7.
